Index: src/joiner.cpp
===================================================================
--- src/joiner.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/joiner.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -17,163 +17,230 @@
 int main(int argc, char **argv)
 {
-	periodentafel *periode = NULL; // and a period table of all elements
-	EnergyMatrix Energy;
-	EnergyMatrix Hcorrection;
-	ForceMatrix Force;
-	EnergyMatrix EnergyFragments;
-	EnergyMatrix HcorrectionFragments;
-	ForceMatrix ForceFragments;
-	ForceMatrix Shielding;
-	ForceMatrix ShieldingPAS;
-	ForceMatrix ShieldingFragments;
-	ForceMatrix ShieldingPASFragments;
-	KeySetsContainer KeySet;
-	stringstream prefix;
-	char *dir = NULL;
-	bool Hcorrected = true;
-
-	cout << "Joiner" << endl;
-	cout << "======" << endl;
-
-	// Get the command line options
-	if (argc < 3) {
-		cout << "Usage: " << argv[0] << " <inputdir> <prefix> [elementsdb]" << endl;
-		cout << "<inputdir>\ttherein the output of a molecuilder fragmentation is expected, each fragment with a subdir containing an energy.all and a forces.all file." << endl;
-		cout << "<prefix>\tprefix of energy and forces file." << endl;
-		cout << "[elementsdb]\tpath to elements database, needed for shieldings." << endl;
-		return 1;
-	} else {
-		dir = (char *) Malloc(sizeof(char)*(strlen(argv[2])+2), "main: *dir");
-		strcpy(dir, "/");
-		strcat(dir, argv[2]);
-	}
-	if (argc > 3) {
-		periode = new periodentafel;
-		periode->LoadPeriodentafel(argv[3]);
-	}
-
-	// Test the given directory
-	if (!TestParams(argc, argv))
-		return 1;
-
-	// +++++++++++++++++ PARSING +++++++++++++++++++++++++++++++
-
-	// ------------- Parse through all Fragment subdirs --------
-	if (!Energy.ParseFragmentMatrix(argv[1], dir, EnergySuffix, 0,0)) return 1;
-	Hcorrected = Hcorrection.ParseFragmentMatrix(argv[1], "", HCORRECTIONSUFFIX, 0,0);
-	if (!Force.ParseFragmentMatrix(argv[1], dir, ForcesSuffix, 0,0)) return 1;
-	if (periode != NULL) { // also look for PAS values
-		if (!Shielding.ParseFragmentMatrix(argv[1], dir, ShieldingSuffix, 1, 0)) return 1;
-		if (!ShieldingPAS.ParseFragmentMatrix(argv[1], dir, ShieldingPASSuffix, 1, 0)) return 1;
-	}
-
-	// ---------- Parse the TE Factors into an array -----------------
-	if (!Energy.ParseIndices()) return 1;
-	if (Hcorrected) Hcorrection.ParseIndices();
-
-	// ---------- Parse the Force indices into an array ---------------
-	if (!Force.ParseIndices(argv[1])) return 1;
-
-	// ---------- Parse the shielding indices into an array ---------------
-	if (periode != NULL) { // also look for PAS values
-		if(!Shielding.ParseIndices(argv[1])) return 1;
-		if(!ShieldingPAS.ParseIndices(argv[1])) return 1;
-	}
-
-	// ---------- Parse the KeySets into an array ---------------
-	if (!KeySet.ParseKeySets(argv[1], Force.RowCounter, Force.MatrixCounter)) return 1;
-
-	if (!KeySet.ParseManyBodyTerms()) return 1;
-	if (!EnergyFragments.AllocateMatrix(Energy.Header, Energy.MatrixCounter, Energy.RowCounter, Energy.ColumnCounter)) return 1;
-	if (Hcorrected)	HcorrectionFragments.AllocateMatrix(Hcorrection.Header, Hcorrection.MatrixCounter, Hcorrection.RowCounter, Hcorrection.ColumnCounter);
-	if (!ForceFragments.AllocateMatrix(Force.Header, Force.MatrixCounter, Force.RowCounter, Force.ColumnCounter)) return 1;
-	if (periode != NULL) { // also look for PAS values
-		if (!ShieldingFragments.AllocateMatrix(Shielding.Header, Shielding.MatrixCounter, Shielding.RowCounter, Shielding.ColumnCounter)) return 1;
-		if (!ShieldingPASFragments.AllocateMatrix(ShieldingPAS.Header, ShieldingPAS.MatrixCounter, ShieldingPAS.RowCounter, ShieldingPAS.ColumnCounter)) return 1;
-	}
-
-	// ----------- Resetting last matrices (where full QM values are stored right now)
-	if(!Energy.SetLastMatrix(0., 0)) return 1;
-	if(!Force.SetLastMatrix(0., 2)) return 1;
-	if (periode != NULL) { // also look for PAS values
-		if(!Shielding.SetLastMatrix(0., 2)) return 1;
-		if(!ShieldingPAS.SetLastMatrix(0., 2)) return 1;
-	}
-
-	// +++++++++++++++++ SUMMING +++++++++++++++++++++++++++++++
-
-	// --------- sum up and write for each order----------------
-	for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
-		// --------- sum up energy --------------------
-		cout << "Summing energy of order " << BondOrder+1 << " ..." << endl;
-		if (!EnergyFragments.SumSubManyBodyTerms(Energy, KeySet, BondOrder)) return 1;
-		if (Hcorrected) {
-			HcorrectionFragments.SumSubManyBodyTerms(Hcorrection, KeySet, BondOrder);
-			if (!Energy.SumSubEnergy(EnergyFragments, &HcorrectionFragments, KeySet, BondOrder, 1.)) return 1;
-			if (Hcorrected) Hcorrection.SumSubEnergy(HcorrectionFragments, NULL, KeySet, BondOrder, 1.);
-		} else
-			if (!Energy.SumSubEnergy(EnergyFragments, NULL, KeySet, BondOrder, 1.)) return 1;
-		// --------- sum up Forces --------------------
-		cout << "Summing forces of order " << BondOrder+1 << " ..." << endl;
-		if (!ForceFragments.SumSubManyBodyTerms(Force, KeySet, BondOrder)) return 1;
-		if (!Force.SumSubForces(ForceFragments, KeySet, BondOrder, 1.)) return 1;
-		if (periode != NULL) { // also look for PAS values
-			cout << "Summing shieldings of order " << BondOrder+1 << " ..." << endl;
-			if (!ShieldingFragments.SumSubManyBodyTerms(Shielding, KeySet, BondOrder)) return 1;
-			if (!Shielding.SumSubForces(ShieldingFragments, KeySet, BondOrder, 1.)) return 1;
-			if (!ShieldingPASFragments.SumSubManyBodyTerms(ShieldingPAS, KeySet, BondOrder)) return 1;
-			if (!ShieldingPAS.SumSubForces(ShieldingPASFragments, KeySet, BondOrder, 1.)) return 1;
-		}
-
-		// --------- write the energy and forces file --------------------
-		prefix.str(" ");
-		prefix << dir << OrderSuffix << (BondOrder+1);
-		cout << "Writing files " << argv[1] << prefix.str() << ". ..." << endl;
-		// energy
-		if (!Energy.WriteLastMatrix(argv[1], (prefix.str()).c_str(), EnergySuffix)) return 1;
-		// forces
-		if (!Force.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ForcesSuffix)) return 1;
-		// shieldings
-		if (periode != NULL) { // also look for PAS values
-			if (!Shielding.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ShieldingSuffix)) return 1;
-			if (!ShieldingPAS.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ShieldingPASSuffix)) return 1;
-		}
-	}
-	// fragments
-	prefix.str(" ");
-	prefix << dir << EnergyFragmentSuffix;
-	if (!EnergyFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
-	if (Hcorrected) {
-		prefix.str(" ");
-		prefix << dir << HcorrectionFragmentSuffix;
-		if (!HcorrectionFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
-	}
-	prefix.str(" ");
-	prefix << dir << ForceFragmentSuffix;
-	if (!ForceFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
-	if (!CreateDataFragment(EnergyFragments, KeySet, argv[1], FRAGMENTPREFIX ENERGYPERFRAGMENT, "fragment energy versus the Fragment No", "today", CreateEnergy)) return 1;
-	if (periode != NULL) { // also look for PAS values
-		prefix.str(" ");
-		prefix << dir << ShieldingFragmentSuffix;
-		if (!ShieldingFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
-		prefix.str(" ");
-		prefix << dir << ShieldingPASFragmentSuffix;
-		if (!ShieldingPASFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
-	}
-
-	// write last matrices as fragments into central dir (not subdir as above), for analyzer to know index bounds
-	if (!Energy.WriteLastMatrix(argv[1], dir, EnergyFragmentSuffix)) return 1;
-	if (Hcorrected) Hcorrection.WriteLastMatrix(argv[1], dir, HcorrectionFragmentSuffix);
-	if (!Force.WriteLastMatrix(argv[1], dir, ForceFragmentSuffix)) return 1;
-	if (periode != NULL) { // also look for PAS values
-		if (!Shielding.WriteLastMatrix(argv[1], dir, ShieldingFragmentSuffix)) return 1;
-		if (!ShieldingPAS.WriteLastMatrix(argv[1], dir, ShieldingPASFragmentSuffix)) return 1;
-	}
-
-	// exit
-	delete(periode);
-	Free((void **)&dir, "main: *dir");
-	cout << "done." << endl;
-	return 0;
+  periodentafel *periode = NULL; // and a period table of all elements
+  EnergyMatrix Energy;
+  EnergyMatrix EnergyFragments;
+  
+  EnergyMatrix Hcorrection;
+  EnergyMatrix HcorrectionFragments;
+  
+  ForceMatrix Force;
+  ForceMatrix ForceFragments;
+
+  HessianMatrix Hessian;
+  HessianMatrix HessianFragments;
+  
+  ForceMatrix Shielding;
+  ForceMatrix ShieldingPAS;
+  ForceMatrix ShieldingFragments;
+  ForceMatrix ShieldingPASFragments;
+  ForceMatrix Chi;
+  ForceMatrix ChiPAS;
+  ForceMatrix ChiFragments;
+  ForceMatrix ChiPASFragments;
+  KeySetsContainer KeySet;  
+  stringstream prefix;
+  char *dir = NULL;
+  bool NoHCorrection = false;
+  bool NoHessian = false;
+
+  cout << "Joiner" << endl;
+  cout << "======" << endl;
+
+  // Get the command line options
+  if (argc < 3) {
+    cout << "Usage: " << argv[0] << " <inputdir> <prefix> [elementsdb]" << endl;
+    cout << "<inputdir>\ttherein the output of a molecuilder fragmentation is expected, each fragment with a subdir containing an energy.all and a forces.all file." << endl;
+    cout << "<prefix>\tprefix of energy and forces file." << endl;
+    cout << "[elementsdb]\tpath to elements database, needed for shieldings." << endl;
+    return 1;
+  } else {
+    dir = (char *) Malloc(sizeof(char)*(strlen(argv[2])+2), "main: *dir");
+    strcpy(dir, "/");
+    strcat(dir, argv[2]);
+  }
+  if (argc > 3) {
+    periode = new periodentafel;
+    periode->LoadPeriodentafel(argv[3]);
+  }
+
+  // Test the given directory
+  if (!TestParams(argc, argv))
+    return 1;
+
+  // +++++++++++++++++ PARSING +++++++++++++++++++++++++++++++
+
+  // ------------- Parse through all Fragment subdirs --------
+  if (!Energy.ParseFragmentMatrix(argv[1], dir, EnergySuffix, 0,0)) return 1;
+  if (!Hcorrection.ParseFragmentMatrix(argv[1], "", HCORRECTIONSUFFIX, 0,0)) {
+    NoHCorrection = true;
+    cout << "No HCorrection matrices found, skipping these." << endl;
+  }
+  if (!Force.ParseFragmentMatrix(argv[1], dir, ForcesSuffix, 0,0)) return 1;
+  if (!Hessian.ParseFragmentMatrix(argv[1], dir, HessianSuffix, 0,0)) {
+    NoHessian = true;
+    cout << "No hessian matrices found, skipping these." << endl;
+  }
+  if (periode != NULL) { // also look for PAS values
+    if (!Shielding.ParseFragmentMatrix(argv[1], dir, ShieldingSuffix, 1, 0)) return 1;
+    if (!ShieldingPAS.ParseFragmentMatrix(argv[1], dir, ShieldingPASSuffix, 1, 0)) return 1;
+    if (!Chi.ParseFragmentMatrix(argv[1], dir, ChiSuffix, 1, 0)) return 1;
+    if (!ChiPAS.ParseFragmentMatrix(argv[1], dir, ChiPASSuffix, 1, 0)) return 1;
+  }
+
+  // ---------- Parse the TE Factors into an array -----------------
+  if (!Energy.InitialiseIndices()) return 1;
+  if (!NoHCorrection) 
+    Hcorrection.InitialiseIndices();
+  
+  // ---------- Parse the Force indices into an array ---------------
+  if (!Force.ParseIndices(argv[1])) return 1;
+
+  // ---------- Parse the Hessian (=force) indices into an array ---------------
+  if (!NoHessian)
+    if (!Hessian.InitialiseIndices((class MatrixContainer *)&Force)) return 1;
+
+  // ---------- Parse the shielding indices into an array ---------------
+  if (periode != NULL) { // also look for PAS values
+    if(!Shielding.ParseIndices(argv[1])) return 1;
+    if(!ShieldingPAS.ParseIndices(argv[1])) return 1;
+    if(!Chi.ParseIndices(argv[1])) return 1;
+    if(!ChiPAS.ParseIndices(argv[1])) return 1;
+  }
+
+  // ---------- Parse the KeySets into an array ---------------
+  if (!KeySet.ParseKeySets(argv[1], Force.RowCounter, Force.MatrixCounter)) return 1;
+
+  if (!KeySet.ParseManyBodyTerms()) return 1;
+
+  if (!EnergyFragments.AllocateMatrix(Energy.Header, Energy.MatrixCounter, Energy.RowCounter, Energy.ColumnCounter)) return 1;
+  if (!NoHCorrection)  
+    HcorrectionFragments.AllocateMatrix(Hcorrection.Header, Hcorrection.MatrixCounter, Hcorrection.RowCounter, Hcorrection.ColumnCounter);
+  if (!ForceFragments.AllocateMatrix(Force.Header, Force.MatrixCounter, Force.RowCounter, Force.ColumnCounter)) return 1;
+  if (!NoHessian)
+    if (!HessianFragments.AllocateMatrix(Hessian.Header, Hessian.MatrixCounter, Hessian.RowCounter, Hessian.ColumnCounter)) return 1;
+  if (periode != NULL) { // also look for PAS values
+    if (!ShieldingFragments.AllocateMatrix(Shielding.Header, Shielding.MatrixCounter, Shielding.RowCounter, Shielding.ColumnCounter)) return 1;
+    if (!ShieldingPASFragments.AllocateMatrix(ShieldingPAS.Header, ShieldingPAS.MatrixCounter, ShieldingPAS.RowCounter, ShieldingPAS.ColumnCounter)) return 1;
+    if (!ChiFragments.AllocateMatrix(Chi.Header, Chi.MatrixCounter, Chi.RowCounter, Chi.ColumnCounter)) return 1;
+    if (!ChiPASFragments.AllocateMatrix(ChiPAS.Header, ChiPAS.MatrixCounter, ChiPAS.RowCounter, ChiPAS.ColumnCounter)) return 1;
+  }
+
+  // ----------- Resetting last matrices (where full QM values are stored right now)
+  if(!Energy.SetLastMatrix(0., 0)) return 1;
+  if(!Force.SetLastMatrix(0., 2)) return 1;
+  if (!NoHessian)
+    if (!Hessian.SetLastMatrix(0., 0)) return 1;
+  if (periode != NULL) { // also look for PAS values
+    if(!Shielding.SetLastMatrix(0., 2)) return 1;
+    if(!ShieldingPAS.SetLastMatrix(0., 2)) return 1;
+    if(!Chi.SetLastMatrix(0., 2)) return 1;
+    if(!ChiPAS.SetLastMatrix(0., 2)) return 1;
+  }
+
+  // +++++++++++++++++ SUMMING +++++++++++++++++++++++++++++++
+
+  // --------- sum up and write for each order----------------
+  for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
+    // --------- sum up energy --------------------
+    cout << "Summing energy of order " << BondOrder+1 << " ..." << endl;
+    if (!EnergyFragments.SumSubManyBodyTerms(Energy, KeySet, BondOrder)) return 1;
+    if (!NoHCorrection) { 
+      HcorrectionFragments.SumSubManyBodyTerms(Hcorrection, KeySet, BondOrder);
+      if (!Energy.SumSubEnergy(EnergyFragments, &HcorrectionFragments, KeySet, BondOrder, 1.)) return 1;
+      Hcorrection.SumSubEnergy(HcorrectionFragments, NULL, KeySet, BondOrder, 1.);
+    } else 
+      if (!Energy.SumSubEnergy(EnergyFragments, NULL, KeySet, BondOrder, 1.)) return 1;
+    // --------- sum up Forces --------------------
+    cout << "Summing forces of order " << BondOrder+1 << " ..." << endl;
+    if (!ForceFragments.SumSubManyBodyTerms(Force, KeySet, BondOrder)) return 1;
+    if (!Force.SumSubForces(ForceFragments, KeySet, BondOrder, 1.)) return 1;
+    // --------- sum up Hessian --------------------
+    if (!NoHessian) {
+      cout << "Summing Hessian of order " << BondOrder+1 << " ..." << endl;
+      if (!HessianFragments.SumSubManyBodyTerms(Hessian, KeySet, BondOrder)) return 1;
+      if (!Hessian.SumSubHessians(HessianFragments, KeySet, BondOrder, 1.)) return 1;
+    }
+    if (periode != NULL) { // also look for PAS values
+      cout << "Summing shieldings and susceptibilities of order " << BondOrder+1 << " ..." << endl;
+      if (!ShieldingFragments.SumSubManyBodyTerms(Shielding, KeySet, BondOrder)) return 1;
+      if (!Shielding.SumSubForces(ShieldingFragments, KeySet, BondOrder, 1.)) return 1;
+      if (!ShieldingPASFragments.SumSubManyBodyTerms(ShieldingPAS, KeySet, BondOrder)) return 1;
+      if (!ShieldingPAS.SumSubForces(ShieldingPASFragments, KeySet, BondOrder, 1.)) return 1;
+      if (!ChiFragments.SumSubManyBodyTerms(Chi, KeySet, BondOrder)) return 1;
+      if (!Chi.SumSubForces(ChiFragments, KeySet, BondOrder, 1.)) return 1;
+      if (!ChiPASFragments.SumSubManyBodyTerms(ChiPAS, KeySet, BondOrder)) return 1;
+      if (!ChiPAS.SumSubForces(ChiPASFragments, KeySet, BondOrder, 1.)) return 1;
+    }
+
+    // --------- write the energy and forces file --------------------
+    prefix.str(" ");
+    prefix << dir << OrderSuffix << (BondOrder+1);
+    cout << "Writing files " << argv[1] << prefix.str() << ". ..." << endl;
+    // energy
+    if (!Energy.WriteLastMatrix(argv[1], (prefix.str()).c_str(), EnergySuffix)) return 1;
+    // forces
+    if (!Force.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ForcesSuffix)) return 1;
+    // hessian
+    if (!NoHessian)
+      if (!Hessian.WriteLastMatrix(argv[1], (prefix.str()).c_str(), HessianSuffix)) return 1;
+    // shieldings
+    if (periode != NULL) { // also look for PAS values
+      if (!Shielding.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ShieldingSuffix)) return 1;
+      if (!ShieldingPAS.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ShieldingPASSuffix)) return 1;
+      if (!Chi.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ChiSuffix)) return 1;
+      if (!ChiPAS.WriteLastMatrix(argv[1], (prefix.str()).c_str(), ChiPASSuffix)) return 1;
+    }
+  }
+  // fragments
+  prefix.str(" ");
+  prefix << dir << EnergyFragmentSuffix;
+  if (!EnergyFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+  if (!NoHCorrection) {
+    prefix.str(" ");
+    prefix << dir << HcorrectionFragmentSuffix;
+    if (!HcorrectionFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+  }
+  prefix.str(" ");
+  prefix << dir << ForceFragmentSuffix;
+  if (!ForceFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+  if (!CreateDataFragment(EnergyFragments, KeySet, argv[1], FRAGMENTPREFIX ENERGYPERFRAGMENT, "fragment energy versus the Fragment No", "today", CreateEnergy)) return 1;
+  if (!NoHessian) {
+    prefix.str(" ");
+    prefix << dir << HessianFragmentSuffix;
+    if (!HessianFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+  }
+  if (periode != NULL) { // also look for PAS values
+    prefix.str(" ");
+    prefix << dir << ShieldingFragmentSuffix;
+    if (!ShieldingFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+    prefix.str(" ");
+    prefix << dir << ShieldingPASFragmentSuffix;
+    if (!ShieldingPASFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+    prefix.str(" ");
+    prefix << dir << ChiFragmentSuffix;
+    if (!ChiFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+    prefix.str(" ");
+    prefix << dir << ChiPASFragmentSuffix;
+    if (!ChiPASFragments.WriteTotalFragments(argv[1], (prefix.str()).c_str())) return 1;
+  }
+
+  // write last matrices as fragments into central dir (not subdir as above), for analyzer to know index bounds
+  if (!Energy.WriteLastMatrix(argv[1], dir, EnergyFragmentSuffix)) return 1;
+  if (!NoHCorrection) Hcorrection.WriteLastMatrix(argv[1], dir, HcorrectionFragmentSuffix);
+  if (!Force.WriteLastMatrix(argv[1], dir, ForceFragmentSuffix)) return 1;
+  if (!NoHessian)
+    if (!Hessian.WriteLastMatrix(argv[1], dir, HessianFragmentSuffix)) return 1;
+  if (periode != NULL) { // also look for PAS values
+    if (!Shielding.WriteLastMatrix(argv[1], dir, ShieldingFragmentSuffix)) return 1;
+    if (!ShieldingPAS.WriteLastMatrix(argv[1], dir, ShieldingPASFragmentSuffix)) return 1;
+    if (!Chi.WriteLastMatrix(argv[1], dir, ChiFragmentSuffix)) return 1;
+    if (!ChiPAS.WriteLastMatrix(argv[1], dir, ChiPASFragmentSuffix)) return 1;
+  }
+
+  // exit
+  delete(periode);
+  Free((void **)&dir, "main: *dir");
+  cout << "done." << endl;
+  return 0;
 };
 
Index: src/linkedcell.cpp
===================================================================
--- src/linkedcell.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/linkedcell.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -6,11 +6,11 @@
 LinkedCell::LinkedCell()
 {
-	LC = NULL;
-	for(int i=0;i<NDIM;i++)
-		N[i] = 0;
-	index = -1;
-	RADIUS = 0.;
-	max.Zero();
-	min.Zero();
+  LC = NULL;
+  for(int i=0;i<NDIM;i++)
+    N[i] = 0;
+  index = -1;
+  RADIUS = 0.;
+  max.Zero();
+  min.Zero();
 };
 
@@ -21,67 +21,67 @@
 LinkedCell::LinkedCell(molecule *mol, double radius)
 {
-	atom *Walker = NULL;
+  atom *Walker = NULL;
 
-	RADIUS = radius;
-	LC = NULL;
-	for(int i=0;i<NDIM;i++)
-		N[i] = 0;
-	index = -1;
-	max.Zero();
-	min.Zero();
-	cout << Verbose(1) << "Begin of LinkedCell" << endl;
-	if (mol->start->next == mol->end) {
-		cerr << "ERROR: molecule contains no atoms!" << endl;
-		return;
-	}
-	// 1. find max and min per axis of atoms
-	Walker = mol->start->next;
-	for (int i=0;i<NDIM;i++) {
-		max.x[i] = Walker->x.x[i];
-		min.x[i] = Walker->x.x[i];
-	}
-	while (Walker != mol->end) {
-		for (int i=0;i<NDIM;i++) {
-			if (max.x[i] < Walker->x.x[i])
-				max.x[i] = Walker->x.x[i];
-			if (min.x[i] > Walker->x.x[i])
-				min.x[i] = Walker->x.x[i];
-		}
-		Walker = Walker->next;
-	}
-	cout << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl;
+  RADIUS = radius;
+  LC = NULL;
+  for(int i=0;i<NDIM;i++)
+    N[i] = 0;
+  index = -1;
+  max.Zero();
+  min.Zero();
+  cout << Verbose(1) << "Begin of LinkedCell" << endl;
+  if (mol->start->next == mol->end) {
+    cerr << "ERROR: molecule contains no atoms!" << endl;
+    return;
+  }
+  // 1. find max and min per axis of atoms
+  Walker = mol->start->next;
+  for (int i=0;i<NDIM;i++) {
+    max.x[i] = Walker->x.x[i];
+    min.x[i] = Walker->x.x[i];
+  }
+  while (Walker != mol->end) {
+    for (int i=0;i<NDIM;i++) {
+      if (max.x[i] < Walker->x.x[i])
+        max.x[i] = Walker->x.x[i];
+      if (min.x[i] > Walker->x.x[i])
+        min.x[i] = Walker->x.x[i];
+    }
+    Walker = Walker->next;
+  }
+  cout << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl;
 
-	// 2. find then umber of cells per axis
-	for (int i=0;i<NDIM;i++) {
-		N[i] = (int)floor((max.x[i] - min.x[i])/RADIUS)+1;
-	}
-	cout << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl;
+  // 2. find then umber of cells per axis
+  for (int i=0;i<NDIM;i++) {
+    N[i] = (int)floor((max.x[i] - min.x[i])/RADIUS)+1;
+  }
+  cout << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl;
 
-	// 3. allocate the lists
-	cout << Verbose(2) << "Allocating cells ... ";
-	if (LC != NULL) {
-		cout << Verbose(1) << "ERROR: Linked Cell list is already allocated, I do nothing." << endl;
-		return;
-	}
-	LC = new LinkedAtoms[N[0]*N[1]*N[2]];
-	for (index=0;index<N[0]*N[1]*N[2];index++) {
-		LC [index].clear();
-	}
-	cout << "done."  << endl;
+  // 3. allocate the lists
+  cout << Verbose(2) << "Allocating cells ... ";
+  if (LC != NULL) {
+    cout << Verbose(1) << "ERROR: Linked Cell list is already allocated, I do nothing." << endl;
+    return;
+  }
+  LC = new LinkedAtoms[N[0]*N[1]*N[2]];
+  for (index=0;index<N[0]*N[1]*N[2];index++) {
+    LC [index].clear();
+  }
+  cout << "done."  << endl;
 
-	// 4. put each atom into its respective cell
+  // 4. put each atom into its respective cell
   cout << Verbose(2) << "Filling cells ... ";
-	Walker = mol->start;
-	while (Walker->next != mol->end) {
-		Walker = Walker->next;
-		for (int i=0;i<NDIM;i++) {
-			n[i] = (int)floor((Walker->x.x[i] - min.x[i])/RADIUS);
-		}
-		index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
-		LC[index].push_back(Walker);
-		//cout << Verbose(2) << *Walker << " goes into cell " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
-	}
+  Walker = mol->start;
+  while (Walker->next != mol->end) {
+    Walker = Walker->next;
+    for (int i=0;i<NDIM;i++) {
+      n[i] = (int)floor((Walker->x.x[i] - min.x[i])/RADIUS);
+    }
+    index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
+    LC[index].push_back(Walker);
+    //cout << Verbose(2) << *Walker << " goes into cell " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
+  }
   cout << "done."  << endl;
-	cout << Verbose(1) << "End of LinkedCell" << endl;
+  cout << Verbose(1) << "End of LinkedCell" << endl;
 };
 
@@ -90,13 +90,13 @@
 LinkedCell::~LinkedCell()
 {
-	if (LC != NULL)
-	for (index=0;index<N[0]*N[1]*N[2];index++)
-		LC[index].clear();
-	delete[](LC);
-	for(int i=0;i<NDIM;i++)
-		N[i] = 0;
-	index = -1;
-	max.Zero();
-	min.Zero();
+  if (LC != NULL)
+  for (index=0;index<N[0]*N[1]*N[2];index++)
+    LC[index].clear();
+  delete[](LC);
+  for(int i=0;i<NDIM;i++)
+    N[i] = 0;
+  index = -1;
+  max.Zero();
+  min.Zero();
 };
 
@@ -106,10 +106,10 @@
 bool LinkedCell::CheckBounds()
 {
-	bool status = true;
-	for(int i=0;i<NDIM;i++)
-		status = status && ((n[i] >=0) && (n[i] < N[i]));
-	if (!status)
-	cerr << "ERROR: indices are out of bounds!" << endl;
-	return status;
+  bool status = true;
+  for(int i=0;i<NDIM;i++)
+    status = status && ((n[i] >=0) && (n[i] < N[i]));
+  if (!status)
+  cerr << "ERROR: indices are out of bounds!" << endl;
+  return status;
 };
 
@@ -120,10 +120,10 @@
 LinkedAtoms* LinkedCell::GetCurrentCell()
 {
-	if (CheckBounds()) {
-		index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
-		return (&(LC[index]));
-	} else {
-		return NULL;
-	}
+  if (CheckBounds()) {
+    index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
+    return (&(LC[index]));
+  } else {
+    return NULL;
+  }
 };
 
@@ -134,18 +134,17 @@
 bool LinkedCell::SetIndexToAtom(const atom &Walker)
 {
-	bool status = false;
-	for (int i=0;i<NDIM;i++) {
-		n[i] = (int)floor((Walker.x.x[i] - min.x[i])/RADIUS);
-	}
-
-	index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
-	if (CheckBounds()) {
-		for (LinkedAtoms::iterator Runner = LC[index].begin(); Runner != LC[index].end(); Runner++)
-			status = status || ((*Runner) == &Walker);
-		return status;
-	} else {
-		cerr << Verbose(1) << "WARN: Atom "<< Walker << " at " << Walker.x << " is out of bounds." << endl;
-		return false;
-	}
+  bool status = false;
+  for (int i=0;i<NDIM;i++) {
+    n[i] = (int)floor((Walker.x.x[i] - min.x[i])/RADIUS);
+  }
+  index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
+  if (CheckBounds()) {
+    for (LinkedAtoms::iterator Runner = LC[index].begin(); Runner != LC[index].end(); Runner++)
+      status = status || ((*Runner) == &Walker);
+    return status;
+  } else {
+    cerr << Verbose(1) << "ERROR: Atom "<< Walker << " at " << Walker.x << " is out of bounds." << endl;
+    return false;
+  }
 };
 
@@ -176,13 +175,13 @@
 bool LinkedCell::SetIndexToVector(const Vector *x)
 {
-	bool status = true;
-	for (int i=0;i<NDIM;i++) {
-		n[i] = (int)floor((x->x[i] - min.x[i])/RADIUS);
-		if (max.x[i] < x->x[i])
-			status = false;
-		if (min.x[i] > x->x[i])
-			status = false;
-	}
-	return status;
+  bool status = true;
+  for (int i=0;i<NDIM;i++) {
+    n[i] = (int)floor((x->x[i] - min.x[i])/RADIUS);
+    if (max.x[i] < x->x[i])
+      status = false;
+    if (min.x[i] > x->x[i])
+      status = false;
+  }
+  return status;
 };
 
